package premium_store.model;

import javax.persistence.*;
import java.util.Objects;

@Entity
public class Level {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = false)
    private int level;

    public Level() {
    }

    public Level(int level) {
        this.level = level;
    }

    //возвращает id
    public Long getId() {
        return id;
    }

    //возвращает нацию
    public int getLevel() {
        return level;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    //метод для сравнения
    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;

        if (o == null || getClass() != o.getClass())
            return false;

        Level level = (Level) o;

        return Objects.equals(id, level.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    //преобразование данных по объекту в строчку
    @Override
    public String toString() {
        return "Level{" +
                "id=" + id +
                ", level='" + level + '}';
    }
}
